package com.example.groracle.Brokers;

import org.apache.commons.codec.digest.Crypt;

import com.example.groracle.DAL.DAO.UserDAO;
import com.example.groracle.Entity.User;
/**
 * Class handling functionality connected with passwords, their generating and validation
 * @author tdosek
 * @version 1.0
 */
public class PasswordHandler {
    /**
     * Constructor of the class
     */
    public PasswordHandler(){
    }
    /**
     * Method validating user's password
     * @param username Name of the user
     * @param password Password that user put in
     * @return Boolean representation of the validation true if user and password passed validation, otherwise false
     */
    public Boolean validatePassword(String username, String password){
	Boolean matched = false;
	UserDAO uDal = new UserDAO();
	User validatedUser = uDal.findUser(username);
	if(validatedUser != null){
	    String storedPass = validatedUser.getPassHash();
	    String storedSalt = validatedUser.getPassSalt();
	    Crypt crypt = new Crypt();
	    matched = storedPass.equals(crypt.crypt(password, storedSalt));
	}else matched = false;
	uDal.closeSession();
	return matched;
    }
    /**
     * Method that provides option to set new password for a user
     * @param username username of the user
     * @param password new password
     * @param email email of the user
     */
    public void setNewPassword(String username, String password, String email){
	Crypt crypt = new Crypt();
	// Encryption used is SHA-256 hence adding salt prefix
	// For more info see: http://commons.apache.org/proper/commons-codec/apidocs/org/apache/commons/codec/digest/Crypt.html
	String encryptedPass = crypt.crypt(password, "$5$" + email);
	UserDAO uDal = new UserDAO();
	User passUser = uDal.findUser(username);
	passUser.setPassHash(encryptedPass);
	passUser.setPassSalt("$5$" + email);
	uDal.updateUser(passUser);
	uDal.closeSession();
    }
}
