package com.example.groracle.DAL.DAO;
import java.util.List;

import org.hibernate.SQLQuery;
import org.hibernate.Session;

import com.example.groracle.DAL.SessionFactoryUtil;
import com.example.groracle.Entity.Agregated.StatLinePerDate;
/**
 * Class implementing operations on top of StatLinePerDate object
 * @author tdosek
 * @version 1.1
 */
public class StatLinePerDateDAO {
    private Session ss = null;
    /**
     * Constructor of the class - only thing to do here is to open session to DB
     */
    public StatLinePerDateDAO(){
	ss = SessionFactoryUtil.getSessionFactory().openSession();
    }
    /**
     * Method returning statistic of lines per date
     * @return List of dates with matching count of lines
     */
    public List<StatLinePerDate> getStat(){
	ss.beginTransaction();
	String sQuery = "SELECT date,count(*) FROM input GROUP BY date";
	SQLQuery query = ss.createSQLQuery(sQuery).addEntity(StatLinePerDate.class);
	List<StatLinePerDate> result = query.list();
	ss.getTransaction().commit();
	return result;
    }
    /**
     * Method for closing the session - it flushes database connection
     */
    public void closeSession(){
	ss.flush();
	ss.clear();
	ss.close();
    }
}
