package com.example.groracle.DAL.DAO;

import java.util.List;

import org.hibernate.SQLQuery;
import org.hibernate.Session;

import com.example.groracle.DAL.SessionFactoryUtil;
import com.example.groracle.Entity.Agregated.StatLinePerPattern;
/**
 * Class implementing operations on top of StatLinePerPattern object
 * @author tdosek
 * @version 1.1
 */
public class StatLinePerPatternDAO {
    private Session ss = null;
    /**
     * Constructor of the class - only thing to do here is to open session to DB
     */
    public StatLinePerPatternDAO(){
	ss = SessionFactoryUtil.getSessionFactory().openSession();
    }
    /**
     * Method returning statistic of lines per pattern
     * @return List of patterns with matching count of lines
     */
    public List<StatLinePerPattern> getStat(){
	ss.beginTransaction();
	String sQuery = "SELECT pattern,count(*) FROM input GROUP BY pattern";
	SQLQuery query = ss.createSQLQuery(sQuery).addEntity(StatLinePerPattern.class);
	List<StatLinePerPattern> result = query.list();
	ss.getTransaction().commit();
	return result;
    }
    /**
     * Method for closing the session - it flushes database connection
     */
    public void closeSession(){
	ss.flush();
	ss.clear();
	ss.close();
    }
}
