package com.example.groracle.Views;

import com.example.groracle.Menu;
import com.vaadin.navigator.Navigator;
import com.vaadin.navigator.View;
import com.vaadin.navigator.ViewChangeListener.ViewChangeEvent;
import com.vaadin.ui.Label;
import com.vaadin.ui.Panel;
import com.vaadin.ui.TextArea;
import com.vaadin.ui.VerticalLayout;
/**
 * Class AboutView represents UI handler for displaying about information
 * to user.
 * @author tdosek
 * @version 1.0
 */
public class AboutView extends Panel implements View {
    public static final String NAME = "About";
    private Navigator navigator = null;
    // Initializing variables for view
    private VerticalLayout header = new VerticalLayout();
    /**
     * Constructor for class AboutView
     * @param navigator variable representing UI navigator class which handles UI element switching
     */
    public AboutView(Navigator navigator){
	this.navigator = navigator;
    }
    /**
     * Initialization method which handles composition of UI for given class
     */
    private void init(){
	setContent(header);
	header.removeAllComponents();
	Menu menu = new Menu(navigator);
	menu.initMenu();
	header.addComponent(menu);
	initAbout();
    }
    /**
     * Initialization method specific to AboutView class. It constructs relevant layout and fills it with data.
     */
    private void initAbout(){
	VerticalLayout panel = new VerticalLayout();
	header.addComponent(panel);
	panel.setWidth("100%");
	panel.setHeight("100%");
	panel.setStyleName("loginEditor");
	
	Label about = new Label("About");
	about.setStyleName("loginName");
	panel.addComponent(about);
	
	TextArea text = new TextArea();
	text.setValue("Hello. \n\n"
		+ "Thank you for using this tool. The tool itself allows you to manage users, "
		+ "grok configurations, hosts, patterns and more."
		+ "\n\n If you have any issues using the tool or suggestions for improvement, just send "
		+ "me a tweet - @TomasDosek is the right place.\n\n"
		+ "Tomas Dosek");
	text.setStyleName("loginName");
	text.setRows(20);
	text.setWidth("400px");
	text.setHeight("100%");
	text.setReadOnly(true);
	panel.addComponent(text);
    }
    @Override
    /*
     * (non-Javadoc)
     * @see com.vaadin.navigator.View#enter(com.vaadin.navigator.ViewChangeListener.ViewChangeEvent)
     */
    public void enter(ViewChangeEvent event) {
	init();	
    }

}
